// Code generated by mockery v2.38.0. DO NOT EDIT.

package aws

import (
	context "context"

	ecs "github.com/aws/aws-sdk-go/service/ecs"
	mock "github.com/stretchr/testify/mock"

	request "github.com/aws/aws-sdk-go/aws/request"
)

// mockEcsClient is an autogenerated mock type for the ecsClient type
type mockEcsClient struct {
	mock.Mock
}

// DescribeTaskDefinitionWithContext provides a mock function with given fields: ctx, input, opts
func (_m *mockEcsClient) DescribeTaskDefinitionWithContext(ctx context.Context, input *ecs.DescribeTaskDefinitionInput, opts ...request.Option) (*ecs.DescribeTaskDefinitionOutput, error) {
	_va := make([]interface{}, len(opts))
	for _i := range opts {
		_va[_i] = opts[_i]
	}
	var _ca []interface{}
	_ca = append(_ca, ctx, input)
	_ca = append(_ca, _va...)
	ret := _m.Called(_ca...)

	if len(ret) == 0 {
		panic("no return value specified for DescribeTaskDefinitionWithContext")
	}

	var r0 *ecs.DescribeTaskDefinitionOutput
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *ecs.DescribeTaskDefinitionInput, ...request.Option) (*ecs.DescribeTaskDefinitionOutput, error)); ok {
		return rf(ctx, input, opts...)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *ecs.DescribeTaskDefinitionInput, ...request.Option) *ecs.DescribeTaskDefinitionOutput); ok {
		r0 = rf(ctx, input, opts...)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*ecs.DescribeTaskDefinitionOutput)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *ecs.DescribeTaskDefinitionInput, ...request.Option) error); ok {
		r1 = rf(ctx, input, opts...)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DescribeTasksRequest provides a mock function with given fields: input
func (_m *mockEcsClient) DescribeTasksRequest(input *ecs.DescribeTasksInput) (*request.Request, *ecs.DescribeTasksOutput) {
	ret := _m.Called(input)

	if len(ret) == 0 {
		panic("no return value specified for DescribeTasksRequest")
	}

	var r0 *request.Request
	var r1 *ecs.DescribeTasksOutput
	if rf, ok := ret.Get(0).(func(*ecs.DescribeTasksInput) (*request.Request, *ecs.DescribeTasksOutput)); ok {
		return rf(input)
	}
	if rf, ok := ret.Get(0).(func(*ecs.DescribeTasksInput) *request.Request); ok {
		r0 = rf(input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*request.Request)
		}
	}

	if rf, ok := ret.Get(1).(func(*ecs.DescribeTasksInput) *ecs.DescribeTasksOutput); ok {
		r1 = rf(input)
	} else {
		if ret.Get(1) != nil {
			r1 = ret.Get(1).(*ecs.DescribeTasksOutput)
		}
	}

	return r0, r1
}

// DescribeTasksWithContext provides a mock function with given fields: _a0, _a1, _a2
func (_m *mockEcsClient) DescribeTasksWithContext(_a0 context.Context, _a1 *ecs.DescribeTasksInput, _a2 ...request.Option) (*ecs.DescribeTasksOutput, error) {
	_va := make([]interface{}, len(_a2))
	for _i := range _a2 {
		_va[_i] = _a2[_i]
	}
	var _ca []interface{}
	_ca = append(_ca, _a0, _a1)
	_ca = append(_ca, _va...)
	ret := _m.Called(_ca...)

	if len(ret) == 0 {
		panic("no return value specified for DescribeTasksWithContext")
	}

	var r0 *ecs.DescribeTasksOutput
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *ecs.DescribeTasksInput, ...request.Option) (*ecs.DescribeTasksOutput, error)); ok {
		return rf(_a0, _a1, _a2...)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *ecs.DescribeTasksInput, ...request.Option) *ecs.DescribeTasksOutput); ok {
		r0 = rf(_a0, _a1, _a2...)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*ecs.DescribeTasksOutput)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *ecs.DescribeTasksInput, ...request.Option) error); ok {
		r1 = rf(_a0, _a1, _a2...)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// RunTaskWithContext provides a mock function with given fields: _a0, _a1, _a2
func (_m *mockEcsClient) RunTaskWithContext(_a0 context.Context, _a1 *ecs.RunTaskInput, _a2 ...request.Option) (*ecs.RunTaskOutput, error) {
	_va := make([]interface{}, len(_a2))
	for _i := range _a2 {
		_va[_i] = _a2[_i]
	}
	var _ca []interface{}
	_ca = append(_ca, _a0, _a1)
	_ca = append(_ca, _va...)
	ret := _m.Called(_ca...)

	if len(ret) == 0 {
		panic("no return value specified for RunTaskWithContext")
	}

	var r0 *ecs.RunTaskOutput
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *ecs.RunTaskInput, ...request.Option) (*ecs.RunTaskOutput, error)); ok {
		return rf(_a0, _a1, _a2...)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *ecs.RunTaskInput, ...request.Option) *ecs.RunTaskOutput); ok {
		r0 = rf(_a0, _a1, _a2...)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*ecs.RunTaskOutput)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *ecs.RunTaskInput, ...request.Option) error); ok {
		r1 = rf(_a0, _a1, _a2...)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// StopTaskWithContext provides a mock function with given fields: _a0, _a1, _a2
func (_m *mockEcsClient) StopTaskWithContext(_a0 context.Context, _a1 *ecs.StopTaskInput, _a2 ...request.Option) (*ecs.StopTaskOutput, error) {
	_va := make([]interface{}, len(_a2))
	for _i := range _a2 {
		_va[_i] = _a2[_i]
	}
	var _ca []interface{}
	_ca = append(_ca, _a0, _a1)
	_ca = append(_ca, _va...)
	ret := _m.Called(_ca...)

	if len(ret) == 0 {
		panic("no return value specified for StopTaskWithContext")
	}

	var r0 *ecs.StopTaskOutput
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *ecs.StopTaskInput, ...request.Option) (*ecs.StopTaskOutput, error)); ok {
		return rf(_a0, _a1, _a2...)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *ecs.StopTaskInput, ...request.Option) *ecs.StopTaskOutput); ok {
		r0 = rf(_a0, _a1, _a2...)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*ecs.StopTaskOutput)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *ecs.StopTaskInput, ...request.Option) error); ok {
		r1 = rf(_a0, _a1, _a2...)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// WaitUntilTaskHealthyWithContext provides a mock function with given fields: ctx, input, opts
func (_m *mockEcsClient) WaitUntilTaskHealthyWithContext(ctx context.Context, input *ecs.DescribeTasksInput, opts ...request.WaiterOption) error {
	_va := make([]interface{}, len(opts))
	for _i := range opts {
		_va[_i] = opts[_i]
	}
	var _ca []interface{}
	_ca = append(_ca, ctx, input)
	_ca = append(_ca, _va...)
	ret := _m.Called(_ca...)

	if len(ret) == 0 {
		panic("no return value specified for WaitUntilTaskHealthyWithContext")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *ecs.DescribeTasksInput, ...request.WaiterOption) error); ok {
		r0 = rf(ctx, input, opts...)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// WaitUntilTasksRunningWithContext provides a mock function with given fields: _a0, _a1, _a2
func (_m *mockEcsClient) WaitUntilTasksRunningWithContext(_a0 context.Context, _a1 *ecs.DescribeTasksInput, _a2 ...request.WaiterOption) error {
	_va := make([]interface{}, len(_a2))
	for _i := range _a2 {
		_va[_i] = _a2[_i]
	}
	var _ca []interface{}
	_ca = append(_ca, _a0, _a1)
	_ca = append(_ca, _va...)
	ret := _m.Called(_ca...)

	if len(ret) == 0 {
		panic("no return value specified for WaitUntilTasksRunningWithContext")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *ecs.DescribeTasksInput, ...request.WaiterOption) error); ok {
		r0 = rf(_a0, _a1, _a2...)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// newMockEcsClient creates a new instance of mockEcsClient. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func newMockEcsClient(t interface {
	mock.TestingT
	Cleanup(func())
}) *mockEcsClient {
	mock := &mockEcsClient{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
